#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2700eight4xi.py">
#<abstract4xi abstract = "fires to direction eight and to distance 2700"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2eight4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2EIGHT - COORDINATE SIGNS OF SHOOT2EIGHT4XI: (X - ,Y - ,Z -)
# -------------------------------------------------------------------------------------------------    
global shot2eight27004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = True
         
shot2eight27004xi = {
                1:'-101x-904y-2648z',
                2:'-1020x-2492y-188z',
                3:'-1026x-202y-2488z',
                4:'-1035x-740y-2381z',
                5:'-1060x-151y-2478z',
                6:'-106x-466y-2657z',
                7:'-1074x-1673y-1826z',
                8:'-1084x-1929y-1546z',
                9:'-1091x-98y-2467z',
                10:'-1092x-698y-2368z',
                11:'-1148x-651y-2355z',
                12:'-1149x-2437y-161z',
                13:'-1171x-1629y-1806z',
                14:'-1192x-1882y-1524z',
                15:'-1201x-601y-2341z',
                16:'-1253x-546y-2328z',
                17:'-1266x-1580y-1786z',
                18:'-1276x-2375y-134z',
                19:'-1298x-1830y-1501z',
                20:'-1301x-488y-2314z',
                21:'-1347x-426y-2300z',
                22:'-1358x-1525y-1765z',
                23:'-137x-485y-2652z',
                24:'-1390x-361y-2286z',
                25:'-1399x-2306y-107z',
                26:'-1401x-1771y-1479z',
                27:'-1449x-1464y-1745z',
                28:'-147x-890y-2544z',
                29:'-1501x-1706y-1456z',
                30:'-1519x-2230y-80z',
                31:'-1536x-1398y-1724z',
                32:'-1599x-1635y-1433z',
                33:'-1620x-1326y-1703z',
                34:'-1634x-2148y-53z',
                35:'-1693x-1559y-1410z',
                36:'-1701x-1250y-1682z',
                37:'-171x-502y-2647z',
                38:'-1744x-2060y-26z',
                39:'-1778x-1168y-1661z',
                40:'-1783x-1477y-1387z',
                41:'-180x-1807y-1997z',
                42:'-1850x-1966y0z',
                43:'-1851x-1082y-1640z',
                44:'-1869x-1390y-1364z',
                45:'-1920x-991y-1618z',
                46:'-194x-2073y-1718z',
                47:'-1950x-1298y-1341z',
                48:'-1984x-895y-1596z',
                49:'-198x-2669y-349z',
                50:'-199x-906y-2535z',
                51:'-2027x-1201y-1317z',
                52:'-2043x-796y-1574z',
                53:'-207x-517y-2641z',
                54:'-2097x-693y-1552z',
                55:'-2099x-1099y-1294z',
                56:'-2145x-586y-1530z',
                57:'-2165x-993y-1270z',
                58:'-2187x-477y-1508z',
                59:'-2224x-364y-1485z',
                60:'-2226x-883y-1246z',
                61:'-2255x-248y-1463z',
                62:'-2280x-769y-1222z',
                63:'-2329x-652y-1198z',
                64:'-2372x-532y-1174z',
                65:'-245x-529y-2636z',
                66:'-253x-919y-2526z',
                67:'-26x-397y-2670z',
                68:'-277x-1815y-1979z',
                69:'-285x-539y-2630z',
                70:'-304x-2077y-1697z',
                71:'-309x-928y-2516z',
                72:'-326x-546y-2623z',
                73:'-338x-2659y-322z',
                74:'-366x-934y-2506z',
                75:'-369x-550y-2617z',
                76:'-376x-1817y-1960z',
                77:'-413x-551y-2610z',
                78:'-416x-2075y-1676z',
                79:'-425x-936y-2496z',
                80:'-458x-548y-2603z',
                81:'-475x-1814y-1942z',
                82:'-477x-2640y-296z',
                83:'-485x-935y-2485z',
                84:'-504x-543y-2596z',
                85:'-50x-421y-2666z',
                86:'-528x-2066y-1655z',
                87:'-546x-930y-2475z',
                88:'-550x-533y-2588z',
                89:'-576x-1805y-1923z',
                90:'-58x-2672y-376z',
                91:'-597x-521y-2581z',
                92:'-5x-371y-2674z',
                93:'-607x-920y-2464z',
                94:'-616x-2614y-269z',
                95:'-641x-2051y-1633z',
                96:'-643x-505y-2572z',
                97:'-669x-907y-2453z',
                98:'-676x-1790y-1904z',
                99:'-690x-485y-2564z',
                100:'-731x-890y-2441z',
                101:'-736x-462y-2556z',
                102:'-752x-2581y-242z',
                103:'-753x-2030y-1612z',
                104:'-776x-1770y-1884z',
                105:'-77x-444y-2661z',
                106:'-782x-435y-2547z',
                107:'-793x-868y-2430z',
                108:'-826x-405y-2538z',
                109:'-84x-1794y-2015z',
                110:'-84x-2063y-1739z',
                111:'-855x-842y-2418z',
                112:'-864x-2003y-1590z',
                113:'-870x-371y-2528z',
                114:'-876x-1743y-1865z',
                115:'-887x-2540y-215z',
                116:'-911x-334y-2519z',
                117:'-916x-812y-2406z',
                118:'-952x-293y-2509z',
                119:'-975x-1969y-1568z',
                120:'-976x-1711y-1845z',
                121:'-976x-778y-2393z',
                122:'-990x-249y-2499z'}
#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire2700eight4xi" usage = "target function for charge2700eight4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire2700eight4xi(queue2eight, consumer_channel2eight, publisher_channel2eight):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2700EIGHT4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2700EIGHT4XI -  QUEUE2EIGHT: ", queue2eight)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2700EIGHT4XI -  CONSUMER_CHANNEL2EIGHT: ", consumer_channel2eight)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2700EIGHT4XI -  PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2700EIGHT4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2eight.put(shot2eight27004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2700EIGHT4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2700EIGHT4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2700EIGHT4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2eight8shot2eight27004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2eight8shot2eight27004xi</nack2put4xi>" 
            
        publisher_channel2eight.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2700EIGHT4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2700EIGHT4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2700EIGHT4XI - RETURNING QUEUE OBJECT QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi())  
        # 
            
    return queue2eight    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2700eight4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                                  